*
* ==================================================
*
*   Led11.asm       Blinking Led File  
*                                 
*   Version:        1.0   Released 5/23/2002
*   Author:         Gary Karnes 
*   Compiler:       As11
*   Platform:       Axiom CME11E9-EVBU
*   Purpose:        Blink a Led  
*   Useage:         Free to copy
* ==================================================
*  Hardware
*   Led with cathode connected thru resistor to ground
*   Led anode connected to PB0 PB1 PB2 PB3
*
* Four Blinking Led's
* Using Port B bit 0 thru 3
*          equates
PORTB:     equ $1004
Led1:      equ $01         * PB0 select 
Led2:      equ $02         * PB1 select
Led3:      equ $04         * PB2 select
Led4:      equ $08         * PB3 select
*
           org $0100
*
Main:
           ldx  #PORTB     * load x with address of PortB
           bclr 0,x Led1+Led2+Led3+Led4   * turn all led's off
LED1ON:                   
           bset 0,x Led1   * turn led one on 
           bsr  Delay 
LED1OFF:                   
           bclr 0,x Led1   * turn led two off
           bsr  Delay 
     
* Turn on Led Two
LED2ON:                    
           bset 0,x Led2   * turn led two on
           bsr  Delay 


* Turn off Led Two
LED2OFF:                   
           bclr 0,x Led2   * turn led two off
           bsr  Delay           
LED3ON:                    
           bset 0,x Led3   * turn led three on
           bsr  Delay 
LED3OFF:                   
           bclr 0,x Led3   * turn led three off
           bsr  Delay           
LED4ON:                    
           bset 0,x Led4   * turn led four on
           bsr  Delay 
LED4OFF:                   
           bclr 0,x Led4   * turn led 4 off
           bsr  Delay 
           bra  Main       * loop forever
*               
* Delay     
Delay:
           ldy  #$ffff      
DelayA:
           dey
           bne  DelayA
           rts             * return 
*
