*Axiom Mfg
*by Gary Karnes
*1996
*Keyboard to LCD
*
       OPT  l
       ORG $2000
       JMP  MAIN
LCDBAS EQU  $B5F0
KEYBAS EQU  $B5F4
IO     EQU  $93
OUTA   EQU  $FFB8
BUF1   RMB  1
BUF2   RMB  1
BUF3   RMB  1
BUF4   RMB  1
BUF5   RMB  1
TABLE  FCB  $31,$32,$33,$41
       FCB  $34,$35,$36,$42
       FCB  $37,$38,$39,$43
       FCB  $2A,$30,$23,$44
*
*
MAIN   SEI                    Disable enable interrupts
       JSR  LCDSET            Setup LCD 
       JSR  KEYSET            Setup Keypad
M1     JSR  KEYIN             Get character from keypad
       JSR  LCDOUT            Display on LCD
       JMP  M1
*
*
KEYIN  LDY  #KEYBAS
       CLR  BUF4              Counter
       LDAA #$10              First Row
LOP    CLR  $02,Y             Clear Scan
       LDAB $00,Y             Read Keypad
       ANDB #$F0
       STAB BUF1              Save
       STAA $02,Y             send scan
       LDAB $00,Y             Read Keypad
       ANDB #$F0
       CMPB BUF1              Key found
       BNE  DONE
       LSLA                   Next Row
       ANDA #$F0
       BEQ  KEYIN             No key found
       INC  BUF4
       INC  BUF4
       INC  BUF4
       INC  BUF4
       BRA  LOP
DONE   CLR  BUF3              Counter
       STAB BUF2
LL     ANDB #$10              Find Col 
       LDA  BUF1
       ANDA #$10
       CBA                    Compare
       BNE  FOUND
       INC  BUF3              Increment counter 
       LSR  BUF1
       LSR  BUF2
       LDAB BUF2
       BNE  LL                Not done
FOUND  CMPA BUF5
       BEQ  DD
       STAA BUF5
       JMP  KEYIN 
DD     LDD  #TABLE            Load look up table
       ADDB BUF3
       ADDB BUF4
       XGDY
       LDAA 0,Y
       CMPA #$2A              If keypad is '*' then clear screen
       BNE  NEXT
       JSR  LCDSET
       JMP  KEYIN  
NEXT   LDAB #$02
TT     JSR  DELAY
       DECB 
       BNE  TT
       RTS

LCDOUT STAA  LCDBAS+1
       RTS

LCDSET LDAA  #$3C             2x40 Display
       STAA  LCDBAS
       JSR   DELAY
       LDAA  #$01             Clear & Home
       STAA  LCDBAS
       JSR   DELAY
       LDAA  #$0F             Display on
       STAA  LCDBAS
       JSR   DELAY
       LDAA  #$06             Cursor shift on
       STAA  LCDBAS
       LDAA  #$14             Shift right
       STAA  LCDBAS
       LDAA  #$02             Cursor to Home
       STAA  LCDBAS
       JSR   DELAY
       RTS
DELAY  PSHB
       PSHA
       LDAB  #$F0
DEL1   LDAA  #$F0
DEL2   DECA
       BNE   DEL2 
       DECB
       BNE   DEL1
       PULA
       PULB
       RTS
KEYSET LDAA  #IO
       STAA  KEYBAS+3
       RTS
