*Axiom Mfg
*by Gary Karnes
*1996
*Keyboard to LCD
* FOR CME OR CMM SS:KEYPAD PORT

       OPT  l
       ORG $2000
       JMP  MAIN
LCDBAS EQU  $B5F0
PORTD  EQU  $1008
PDDR   EQU  $1009
PORTE  EQU  $100A
IO     EQU  $3E         * PORT D DIRECTION
OUTA   EQU  $FFB8
BUF1   RMB  1
BUF2   RMB  1
BUF3   RMB  1
BUF4   RMB  1
BUF5   RMB  1
TABLE  FCB  $31,$32,$33,$41
       FCB  $34,$35,$36,$42
       FCB  $37,$38,$39,$43
       FCB  $2A,$30,$23,$44
*
*
MAIN   SEI                    Disable enable interrupts
       JSR  LCDSET            Setup LCD 
       JSR  KEYSET            Setup Keypad
M1     JSR  KEYIN             Get character from keypad
       CMPA #$2A              If keypad is '*' then clear screen
       BNE  M2
       JSR  LCDSET
       BRA  M3  
M2     JSR  LCDOUT            Display on LCD
M3     JSR  ANYKEY            TEST IF KEY IS GONE       
       BEQ  M1                IF YES, FINISHED WITH KEY
       BRA  M3                ELSE, WAIT FOR KEY RELEASE
*
*
KEYIN  
       JSR  ANYKEY            TEST FOR ANY KEY
       BEQ  KEYIN
*                  KEY FOUND, DECODE KEY
       JSR  KEYSCAN
       TSTA
       BEQ  KEYIN
       PSHA
       JSR  DELAY1
       JSR  KEYSCAN
       PULB
       CBA
       BNE  KEYIN
       RTS
       
KEYSCAN       
       CLRB                   CLEAR KEY NUMBER
       LDAA #$04              COLUMN 1 ON
       JSR  KEYCHK            TEST COLUMN 1
       BNE  KEYROW            KEY IS THIS ROW
       ADDB #4                UPDATE KEY COUNT
       LDAA #$08              COLUMN 2 ON
       JSR  KEYCHK            TEST COLUMN 2
       BNE  KEYROW            KEY IS THIS ROW
       ADDB #4                UPDATE KEY COUNT
       LDAA #$10              COLUMN 3 ON
       JSR  KEYCHK            TEST COLUMN 3
       BNE  KEYROW            KEY IS THIS ROW
       ADDB #4                UPDATE KEY COUNT
       LDAA #$20              COLUMN 4 ON
       JSR  KEYCHK            TEST COLUMN 4
       BEQ  NOKEY             NO KEY FOUND, START OVER
KEYROW
       LSRA                   FIND KEY ROW
       BCS  KEYDONE                                
       INCB
       LSRA
       BCS  KEYDONE
       INCB
       LSRA
       BCS  KEYDONE
       INCB
       LSRA
       BCC  NOKEY             NO KEY FOUND, START OVER
KEYDONE
       PSHX
       CLRA
       ADDD  #TABLE            Load look up table
       XGDX
       LDAA 0,X
       PULX
       RTS
NOKEY  CLRA
       RTS

ANYKEY
       LDX  #PORTD
       LDAA #$3C              ALL COLUMNS ON
KEYCHK       
       STAA 0,X               OUTPUT KEY COLUMNS
       NOP
       NOP
       LDAA 2,X               INPUT KEY ROWS
       ANDA #$0F              MASK FOR KEY ROWS
       RTS                    WAIT FOR KEY

LCDOUT STAA  LCDBAS+1
       RTS

LCDSET LDAA  #$3C             2x40 Display
       STAA  LCDBAS
       JSR   DELAY
       LDAA  #$01             Clear & Home
       STAA  LCDBAS
       JSR   DELAY
       LDAA  #$0F             Display on
       STAA  LCDBAS
       JSR   DELAY
       LDAA  #$06             Cursor shift on
       STAA  LCDBAS
       LDAA  #$14             Shift right
       STAA  LCDBAS
       LDAA  #$02             Cursor to Home
       STAA  LCDBAS
       JSR   DELAY
       RTS

DELAY  PSHB
       PSHA
       LDAB  #$F0
DEL1   LDAA  #$F0
DEL2   DECA
       BNE   DEL2 
       DECB
       BNE   DEL1
       PULA
       PULB
       RTS

DELAY1
        PSHX
        LDX     #20000
DELLP   DEX
        BNE     DELLP
        PULX
        RTS


KEYSET LDAA  #IO
       STAA  PDDR
       RTS
