/* M68HC11 serial line operations
   Copyright (C) 1999 Free Software Foundation, Inc.
   Written by Stephane Carrez (stcarrez@worldnet.fr)	

This file is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

In addition to the permissions in the GNU General Public License, the
Free Software Foundation gives you unlimited permission to link the
compiled version of this file with other programs, and to distribute
those programs without any restriction coming from the use of this
file.  (The General Public License restrictions do apply in other
respects; for example, they cover modification of the file, and
distribution when not linked into another program.)

This file is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

	.sect .text
	.globl serial_send
	.globl serial_recv
	.globl serial_init
	.globl serial_print
	.globl serial_getline
	.globl _serial_print
		
	.globl _io_ports

_io_ports= 0x1000
	
	BAUD = 0x2b
	SCCR1= 0x2c
	SCCR2= 0x2d
	SCSR = 0x2e
	SCDR = 0x2f

serial_send:
	ldaa _io_ports+SCSR
	bge  serial_send
	stab _io_ports+SCDR
	ldab _io_ports+SCCR2
	orab #0x8
	stab _io_ports+SCCR2
	rts

serial_recv:
	ldaa _io_ports+SCSR
	bita #0x20
	beq serial_recv
	ldab _io_ports+SCDR
	rts

serial_init:
#	ldaa #0x30
	ldaa #0x33
#	ldaa #0xff
	staa _io_ports+BAUD
	ldaa #0
	staa _io_ports+SCCR1
	ldaa #0xc
	staa _io_ports+SCCR2
	rts

serial_print:
	xgdx
_serial_print:
	ldab 0,x
	beq  ret
	bsr serial_send
	inx
	bra _serial_print
ret:
	rts

serial_getline:
	bsr serial_recv
	stab 0,x
	inx
	clr  0,x
	cmpb #0x0D
	beq  ret
	cmpb #0x0A
	bne  serial_getline
	rts
